      program dist
c23456789012345678901234567890123456789012345678901234567890123456789012
C----
C---- dist finds restricted distances between atom pairs in
C---- coordinate file
C----
C---- distances are written in Angstroms!
C----
C---- by Bert de Groot, 1996-1998
C----

      implicit none

      integer maxdim,maxcat

      include 'params.f'

      parameter (maxdim=3*maxat,maxcat=100)

      character*80 sdum,dsspnam,libdir,innam,outnam,disnam,gronam

      character*5 atnam(maxat),resnam(maxat),dum1,dum2,
     &     oldres,type(maxat)

      character*4 cdum1,cdum2

      character*1 hst(maxat),chainid(maxat),oldchain,pol(maxat)

      logical isring(maxat),gvfisf,lh(maxat),had,had1,groflg,pdbflg,
     &     hflg,dsspflg,notall,nonflg,isqring(maxat)

      integer i,j,k,l,m,nat,resnr(maxat),b1(maxbonds),n14,
     &     b2(maxbonds),atnr(maxat),n13,nring,nomega,npp,
     &     nnonbond,pp1(maxat),pp2(maxat),ntpp,
     &     nrpp,nhst,idum,jdum,nh,findatom,donacc(maxat),
     &     i1,i2,idum1,nres,mindis,r(maxat),nwarn,
     &     noth,nbond,npair(maxat),ihad(maxat,maxpairs),nargs,gvflen,
     &     iargc,resid(maxat),findatom2,ibonds(maxat),jbonds(maxat),
     &     term(maxat),ndist,hbo(4,maxat),hbond(2,maxat),nhbo,nhbo_tight

      real xref(maxdim),getlen,len,lb,ub,charge(maxat),
     &     atrad(2,maxat),rcut,weight(maxat),lsig,usig,
     &     lenpp(maxat),chdis,hbene(4,maxat),dacc(maxat),
     &     hbdis,sigma(maxcat,maxcat,2),acc(maxat),getlsig1,getlsig2,
     &     getusig1,getusig2,damp

      nring=0
      nomega=0
      npp=0
      n14=0
      nnonbond=0
      ntpp=0
      nrpp=0
      nhst=0
      nh=0
      noth=0
      damp=1.0
      do i=1,maxat
         do j=1,maxpairs
            ihad(i,j)=0
         enddo
      enddo
      do i=1,maxat
         dacc(i)=1000.0
         npair(i)=0
         term(i)=0
         weight(i)=1.0
      enddo
      rcut=4.0
      mindis=100
      groflg=.false.
      pdbflg=.false.
      hflg=.false.
      dsspflg=.false.
      nonflg=.false.
      outnam='dist.pdb'
      gronam='dist.gro'
      disnam='dist.dat'
      oldres='xxxxx'
      oldchain='Z'
      notall=.false.
      nhbo=0
      nhbo_tight=0
      nwarn=0
C----
C---- check for library environment variable
C----
      call getenv('CONCOORDLIB',libdir)
C----
C---- parse command line
C----
      nargs=iargc()
      if (nargs.eq.0) call usage()
      j=0
 10   continue
      j=j+1
      call getarg(j,sdum)
      call gvstcp(sdum)
      if (sdum(1:1).ne.'-') then
         call usage()
      else if (sdum(1:2).eq.'-g') then
         groflg=.true.
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,innam)
      else if (sdum(1:2).eq.'-p') then
         pdbflg=.true.
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,innam)
      else if (sdum(1:2).eq.'-r') then
         hflg=.true.
      else if (sdum(1:3).eq.'-nb') then
         nonflg=.true.
      else if (sdum(1:2).eq.'-c') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,sdum)
         read (sdum,*) rcut
      else if (sdum(1:2).eq.'-m') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,sdum)
         read (sdum,*) mindis
      else if (sdum(1:3).eq.'-op') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,outnam)
      else if (sdum(1:3).eq.'-og') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,gronam)
      else if (sdum(1:3).eq.'-od') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,disnam)
      else if (sdum(1:5).eq.'-dssp') then
         dsspflg=.true.
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,dsspnam)
      else if (sdum(1:5).eq.'-damp') then
         if (j.ge.nargs) call usage()
         j=j+1
         call getarg(j,sdum)
         read (sdum,*) damp   
      else if (sdum(1:2).eq.'-h') then
         call manual()
      else
         call gvstcp(sdum)
         write(0,1250) sdum(1:40)
         write(0,*)
         call usage()
      endif

      if (j.lt.nargs) goto 10

      if (.not.pdbflg.and..not.groflg) then
         write(0,1251)
         call usage()
      endif
      if (pdbflg.and.groflg) then
         write(0,1252)
         call usage()
      endif
C----
C---- write input params to stdout
C----
      write(6,1200)
      call gvstcp (innam)
      if (pdbflg) write(6,1201) innam(1:40)
      if (groflg) write(6,1202) innam(1:40)
      call gvstcp (dsspnam)
      if (dsspflg) then
         write(6,1204) dsspnam(1:40)
      else
         write(6,1302)
         write(6,1203)
         write(6,1302)
         nwarn=nwarn+1
      endif
      write(6,1208) rcut
      write(6,1209) mindis
      call gvstcp(disnam)
      write(6,1210) disnam(1:40)
      call gvstcp(outnam)
      write(6,1211) outnam(1:40)
      call gvstcp(gronam)
      write(6,1212) gronam(1:40)
      if (hflg) then
         write(6,1206)
      else
         write(6,1205)
      endif
      if (nonflg) then
         write(6,1215)
      else
         write(6,1216)
      endif
C----
C---- check for existence of files and open
C----
      write(6,1220)
      call bbopenr(1,innam)

      if (dsspflg.and..not.gvfisf(dsspnam)) then
         write(0,1001)
         call gvstcp(dsspnam)
         write(0,1000) dsspnam
         stop
      endif

      call bbopenw(11,disnam)
      call bbopenw(12,outnam)
C----
C---- read reference positions, gromos87 formatted
C---- coordinate file format
C----
      nres=0
      idum=498327
      oldres='xxxxx'
      if (.not.groflg) goto 40
      read (1,1000,end=20,err=30) sdum
      read (1,1005,end=20,err=30) nat
      write (6,2010) nat
      if (nat.gt.maxat) then
         write(0,*) 'Increase parameter MAXAT and compile again'
         stop
      endif
      do i=1,nat
         lh(i)=.false.
         chainid(i)=' '
         read (1,1010,end=20,err=30) jdum,resnam(i),atnam(i),
     &        atnr(i),xref(3*i-2),xref(3*i-1),xref(3*i)
         if(jdum.ne.idum.or.resnam(i).ne.oldres) nres=nres+1
         resnr(i)=nres
         idum=jdum
         oldres=resnam(i)
      enddo
      goto 40
 20   write(0,*) 'unexpected end of file while reading:'
      call gvstcp(innam)
      write(0,*) innam
      stop
 30   write(0,*) 'error while reading:'
      call gvstcp(innam)
      write(0,*) innam
      stop
 40   continue
C----
C---- read pdb file
C----
      if (.not.pdbflg) goto 80
      nat=0
      nres=1
      cdum2='xxxx'
 50   continue
      read(1,1000,err=60,end=70) sdum
      if ((sdum(1:4).ne.'ATOM').and.(sdum(1:4).ne.'HETA')) goto 50
      nat=nat+1
      if (nat.gt.maxat) then
         write(0,*) 'Increase parameter MAXAT and compile again'
         stop
      endif
      read(sdum,1150) atnam(nat),resnam(nat),chainid(nat),cdum1,
     &                xref(3*nat-2),xref(3*nat-1),xref(3*nat),
     &                weight(nat)
      if (nat.gt.1) then
         if (((cdum1.ne.cdum2).or.(oldres.ne.resnam(nat))).or.
     &       (chainid(nat).ne.oldchain)) nres=nres+1
      endif
      if (abs(weight(nat)).gt.0.01) weight(nat)=1.0
c      weight(nat)=1.0
      if (abs(weight(nat)).le.0.01) notall=.true. 
      if (atnam(nat).ne.'     ') then
         call gvsshr(atnam(nat),5)
      else
         write(0,*) 'Encountered empty atom name for atom number',nat
         stop
      endif
      resnr(nat)=nres
      atnr(nat)=nat
      cdum2=cdum1
      oldres=resnam(nat)
      oldchain=chainid(nat)
      goto 50
 60   write(0,*) 'error while reading:'
      call gvstcp(innam)
      write(0,*) innam
      stop
 70   continue
      if (nat.eq.0) then
         write(0,*) 'unexpected end of file while reading:'
         call gvstcp(innam)
         write(0,*) innam
         stop
      endif
      write (6,2010) nat
      do i=1,3*nat
         xref(i)=xref(i)/10.0
      enddo
 80   continue
      close(1)

      if (notall) write(6,1302)
      if (notall) write(6,1300)
      if (notall) write(6,1301)
      if (notall) write(6,1302)
      if (notall) nwarn=nwarn+1
C----
C---- select atoms, remove double entries, and H's when required
C----
      do i=1,nat
         dum1=atnam(i)
         call gvstcp(dum1)
         if ((dum1(1:1).ne.'H'.and.dum1(1:1).ne.'1'.and.
     &        dum1(1:1).ne.'2'.and.dum1(1:1).ne.'3').or.hflg) then
            if (i.gt.1) then
               if (.not.(atnam(i-1).eq.atnam(i).and.resnr(i-1).eq.
     &              resnr(i))) then
                  nh=nh+1
                  lh(i)=.true.
               endif
            else
               nh=nh+1
               lh(i)=.true.
            endif
         endif
      enddo
C----
C---- shift residue/atom numbers
C----
      idum=resnr(1)
      idum1=atnr(1)
      do i=1,nat
         resnr(i)=resnr(i)-idum+1
         atnr(i)=atnr(i)-idum1+1
      enddo
C----
C---- check nr of residues
C----
      if (nres.gt.maxres) then
         write(0,*) 'error - increase parameter MAXRES'
         stop
      endif
      write(6,2025) nres
      write (6,2020) nh
C----
C---- only keep selected atoms
C----
      idum=0
      do i=1,nat
         if (lh(i)) then
            idum=idum+1
            resnr(idum)=resnr(i)
            atnr(idum)=atnr(i)
            resnam(idum)=resnam(i)
            atnam(idum)=atnam(i)
            xref(3*idum-2)=xref(3*i-2)
            xref(3*idum-1)=xref(3*i-1)
            xref(3*idum)=xref(3*i)
            weight(idum)=weight(i)
            chainid(idum)=chainid(i)
         endif
      enddo
      nat=nh
C----
C---- rename atoms
C----
      call rename_atoms(atnam,resnam,nat)
C----
C---- write output stucture (selected atoms only)
C----
      idum=0
      write(12,5000)
      do i=1,nat
         dum1=atnam(i)
         call gvsshl(dum1)
         if (gvflen(dum1).lt.4) then
            write(cdum1,1152) dum1(1:3)
         else
            cdum1=dum1(1:4)
         endif
         write (12,1151) i,cdum1,resnam(i)(1:3),chainid(i),
     &        resnr(i),xref(3*i-2)*10.,xref(3*i-1)*10.,
     &        xref(3*i)*10.,weight(i)
      enddo
      write(12,5001)
      close(12)
C----
C---- make help array resid with pointers to atom
C---- numbers of last atom per residue
C----
      resid(1)=0
      jdum=resnr(1)
      idum=1
      do i=2,nat
         if (resnr(i).ne.jdum) then
            idum=idum+1
            resid(idum)=i-1
         endif
         jdum=resnr(i)
      enddo
      resid(nres+1)=nat
      if (idum.ne.nres) then
         write(0,*) 'bug: nr. of residues inconsistent:',idum,nres
         stop
      endif
C----
C---- write gromos coordinate files
C----
      call bbopenw(12,gronam)
      write (12,*) 'coordinates generated by dis'
      write (12,1005) nh
      idum=0
      do i=1,nh
         dum1=atnam(i)
         dum2=resnam(i)
         call gvsshr(dum1,5)
         call gvsshl(dum2)
         write(12,1010) resnr(i),dum2,dum1,i,xref(3*i-2),
     &        xref(3*i-1),xref(3*i)
      enddo
      close(12)
C----
C---- determine which are the terminal residues
C----
      call getterm(atnam,resid,xref,nres,term)
C----
C---- perform dssp for secondary structure and accessibility information
C----
      if (dsspflg) then
         call dodssp(xref,nat,atnam,resnam,resnr,dsspnam,hst,dacc,hbo,
     &        hbene,r)
         write (6,2040)
         idum=(nres-1)/50+1
         do i=1,idum
            jdum=nres-(i-1)*50
            if (jdum.gt.50) jdum=50
            write (6,2042) (((i-1)*50+j)/10+1,j=1,jdum,10)
            write (6,2045) (mod(j,10),j=1,jdum)
            write (6,2050) (hst((i-1)*50+j),j=1,jdum)
            write (6,*)
         enddo
C-------
C------- sort hbonds
C-------
         nhbo=1
         do i=1,nres
            do j=1,4
               if ((j.eq.1.or.j.eq.3).and.hbene(j,i).le.-0.8) then
                  hbond(1,nhbo)=findatom(r(i),atnam,resid,'    N')
                  idum=findatom(r(i+hbo(j,i)),atnam,resid,'    O')
                  if (idum.eq.0) 
     &                 idum=findatom(r(i+hbo(j,i)),atnam,resid,'   O1')
                  hbond(2,nhbo)=idum
               else if ((j.eq.2.or.j.eq.4).and.hbene(j,i).le.-0.8) then
                  idum=findatom(r(i),atnam,resid,'    O')
                  if (idum.eq.0) 
     &                 idum=findatom(r(i+hbo(j,i)),atnam,resid,'   O1')
                  hbond(1,nhbo)=idum
                  hbond(2,nhbo)=findatom(r(i+hbo(j,i)),atnam,resid,
     &                 '    N')
               endif
               if (hbond(1,nhbo).ne.0.and.hbond(2,nhbo).ne.0) 
     &              nhbo=nhbo+1
            enddo
         enddo
         nhbo_tight=nhbo-1
         do i=1,nres
            do j=1,4
               if ((j.eq.1.or.j.eq.3).and.(hbene(j,i).lt.-0.2.and.
     &              hbene(j,i).gt.-0.8)) then
                  hbond(1,nhbo)=findatom(r(i),atnam,resid,'    N')
                  idum=findatom(r(i+hbo(j,i)),atnam,resid,'    O')
                  if (idum.eq.0) 
     &                 idum=findatom(r(i+hbo(j,i)),atnam,resid,'   O1')
                  hbond(2,nhbo)=idum
               else if ((j.eq.2.or.j.eq.4).and.(hbene(j,i).lt.-0.2.and.
     &                 hbene(j,i).gt.-0.8)) then
                  idum=findatom(r(i),atnam,resid,'    O')
                  if (idum.eq.0) 
     &                 idum=findatom(r(i+hbo(j,i)),atnam,resid,'   O1')
                  hbond(1,nhbo)=idum
                  hbond(2,nhbo)=findatom(r(i+hbo(j,i)),atnam,resid,
     &                 '    N')
               endif
               if (hbond(1,nhbo).ne.0.and.hbond(2,nhbo).ne.0) 
     &              nhbo=nhbo+1
            enddo
         enddo
         nhbo=nhbo-1
      endif
C----
C---- get distance margins for different types
C----
      call getmargins(sigma,maxcat,libdir,damp)
C----
C---- define atom types
C----
      call getatomtypes(atnam,resnam,type,nat,libdir,hflg)
C----
C---- determine vdw radii
C----
      call getvdwrad(type,atrad,nat,libdir)
C----
C---- determine buried/exposed residues
C----
      do i=1,nat
         acc(i)=dacc(resnr(i))
      enddo
      call getpol(pol,acc,resnam,nat,libdir)
C----
C---- define atoms belonging to rings
C----
      call getring(resnam,atnam,isring,isqring,nat,libdir)
C----
C---- see where the bonds/angles are
C----
      call getbonded(atnam,resnam,resnr,resid,atrad,nat,nres,xref,b1,b2,
     &     npair,ihad,nbond,n13,11,libdir,type,sigma,maxcat,
     &     isring)
C----
C---- look for ring constraints
C----
      write(11,1520)
      lsig=sigma(3,1,1)
      usig=sigma(3,1,2)
      do k=1,nres
         do i=resid(k)+1,resid(k+1)
            do j=resid(k)+1,i-1
               if (isring(i).and.isring(j)) then
                  if (.not.had(i,j,npair,ihad)) then
                     len=getlen(i,j,xref)*10.0
                     lb=len-lsig
                     ub=len+usig
                     write(11,1112) i,j,len,lb,ub
                     nring=nring+1
                  endif
               endif
            enddo
         enddo
      enddo
      write(11,1525)
      lsig=sigma(3,2,1)
      usig=sigma(3,2,2)
      do k=1,nres
         do i=resid(k)+1,resid(k+1)
            do j=resid(k)+1,i-1
               if ((isqring(i).and.isring(j)).or.
     &              (isring(i).and.isqring(j)).or.
     &              (isqring(i).and.isqring(j))) then
                  if (.not.had(i,j,npair,ihad)) then
                     len=getlen(i,j,xref)*10.0
                     lb=len-lsig
                     ub=len+usig
                     write(11,1112) i,j,len,lb,ub
                     nring=nring+1
                  endif
               endif
            enddo
         enddo
      enddo
      write (6,1620) nring
C----
C---- assume fixed omega
C---- therefore, some distances are restricted
C----
      write(11,1540)
      dum1='   CA'
      lsig=sigma(4,1,1)
      usig=sigma(4,1,2)
      do l=1,4
         if (l.gt.2) then
            dum1='    O'
            lsig=sigma(4,2,1)
            usig=sigma(4,2,2)
         endif
         dum2='   CA'
         do k=1,nres-1
            i=findatom(resnr(resid(k)+1),atnam,resid,dum1)
            if (l.eq.2.or.l.eq.4) then
               lsig=sigma(4,2,1)
               usig=sigma(4,2,2)
               if (resnam(resid(k+1)+1)(1:3).eq.'PRO') then
                  dum2='   CD'
               else
                  dum2='    H'
               endif
            endif
            j=findatom(resnr(resid(k)+1)+1,atnam,resid,dum2)
            if (i.ne.0.and.j.ne.0) then
               i1=findatom2(i,atnam,resnr,'    C',nat)
               i2=findatom2(j,atnam,resnr,'    N',nat)
               len=getlen(i,j,xref)*10.0
               ub=len+usig
               lb=len-lsig
               if (len.lt.4.5) then
                  if(.not.had(i,j,npair,ihad)) then
                     write(11,1112) i,j,len,lb,ub
                     nomega=nomega+1
                  endif
               endif
            endif
         enddo
      enddo
      write(6,1640) nomega
C----
C---- phi/psi backbone dihedrals are not free to move between
C---- upper and lower distance bound
C----
C---- first phi
C----
c      write (11,1550)
      dum2='    C'
      do l=1,2
         if (l.gt.1) dum2='   CB'
         do k=1,nres-1
            i=findatom(resnr(resid(k)+1),atnam,resid,'    C')
            j=findatom(resnr(resid(k)+1)+1,atnam,resid,dum2)
            if (i.ne.0.and.j.ne.0) then
               len=getlen(i,j,xref)*10.0
               i1=findatom2(j,atnam,resnr,'    N',nat)
               i2=findatom2(j,atnam,resnr,'   CA',nat)
               if (len.lt.4.5) then
                  if(.not.had1(i,j,npair,ihad)) then
                     npp=npp+1
                     pp1(npp)=i
                     pp2(npp)=j
                     lenpp(npp)=len
                  endif
               endif
            endif
         enddo
      enddo
      dum2='    C'
      do l=1,2
         if (l.gt.1) dum2='   CB'
         do k=1,nres
            if (resnam(resid(k)+1)(1:3).eq.'PRO') then
               dum1='   CD'
            else
               dum1='    H'
            endif
            i=findatom(resnr(resid(k)+1),atnam,resid,dum1)
            j=findatom(resnr(resid(k)+1),atnam,resid,dum2)
            if (i.ne.0.and.j.ne.0) then
               len=getlen(i,j,xref)*10.0
               i1=findatom2(j,atnam,resnr,'    N',nat)
               i2=findatom2(j,atnam,resnr,'   CA',nat)
               if (len.lt.4.5) then
                  if (.not.had1(i,j,npair,ihad)) then
                     npp=npp+1
                     pp1(npp)=i
                     pp2(npp)=j
                     lenpp(npp)=len
                  endif
               endif
            endif
         enddo
      enddo
C----
C---- now psi
C----
      dum1='    N'
      do l=1,2
         if (l.gt.1) dum1='   CB'
         do k=1,nres-1
            i=findatom(resnr(resid(k)+1),atnam,resid,dum1)
            j=findatom(resnr(resid(k)+1)+1,atnam,resid,'    N')
            if (i.ne.0.and.j.ne.0) then
               len=getlen(i,j,xref)*10.0
               i1=findatom2(i,atnam,resnr,'   CA',nat)
               i2=findatom2(i,atnam,resnr,'    C',nat)
               if (len.lt.4.5) then
                  if(.not.had1(i,j,npair,ihad)) then
                     npp=npp+1
                     pp1(npp)=i
                     pp2(npp)=j
                     lenpp(npp)=len
                  endif
               endif
            endif
         enddo
      enddo
      dum1='    N'
      do l=1,2
         if (l.gt.1) dum1='   CB'
         do k=1,nres
            i=findatom(resnr(resid(k)+1),atnam,resid,dum1)
            j=findatom(resnr(resid(k)+1),atnam,resid,'    O')
            if (j.eq.0) 
     &           j=findatom(resnr(resid(k)+1),atnam,resid,'   O1')
            if (i.ne.0.and.j.ne.0) then
               len=getlen(i,j,xref)*10.0
               i1=findatom2(i,atnam,resnr,'   CA',nat)
               i2=findatom2(i,atnam,resnr,'    C',nat)
               if (len.lt.4.5) then
                  if(.not.had1(i,j,npair,ihad)) then
                     npp=npp+1
                     pp1(npp)=i
                     pp2(npp)=j
                     lenpp(npp)=len
                  endif
               endif
            endif
         enddo
      enddo
C----
C---- two categories of phi/psi restricted pairs:
C---- helix/sheet and the rest
C----
C---- first helix/sheet
C----
      if (.not.dsspflg) goto 100
      write(11,1550)
      do i=1,npp
         if ((hst(resnr(pp1(i))).eq.'H'.and.hst(resnr(pp2(i))).eq.'H')
     &    .or.(hst(resnr(pp1(i))).eq.'S'.and.hst(resnr(pp2(i))).eq.'S'))
     &        then
            i1=pp1(i)
            i2=pp2(i)
            if (i1.ne.0.and.i2.ne.0) then
               if (.not.had(i1,i2,npair,ihad)) then
                  lsig=getlsig1(i1,i2,atnam,sigma,maxcat)
                  usig=getusig1(i1,i2,atnam,sigma,maxcat)
                  len=lenpp(i)
                  ub=len+usig
                  lb=len-lsig
                  write(11,1112) i1,i2,len,lb,ub
                  ntpp=ntpp+1
               endif
            endif
         endif
      enddo
      write (6,1650) ntpp
C----
C---- rest
C----
 100  continue
      write(11,1552)
      do i=1,npp
         i1=pp1(i)
         i2=pp2(i)
         if (i1.ne.0.and.i2.ne.0) then
            if (.not.had(i1,i2,npair,ihad)) then
               len=lenpp(i)
               lsig=getlsig2(i1,i2,atnam,resnam,sigma,maxcat)
               usig=getusig2(i1,i2,atnam,resnam,sigma,maxcat)
               ub=len+usig
               lb=len-lsig
               write(11,1112) i1,i2,len,lb,ub
               nrpp=nrpp+1
            endif
         endif
      enddo
      write (6,1652) nrpp
      if (nrpp+ntpp.ne.npp) then
         write (0,*) 'BUG: NRPP+NTPP not equal to NPP !!'
         write(0,*) nrpp+ntpp,npp
         stop
      endif
C----
C---- search for other 1-4 pairs
C----
C---- for all 1234 pairs, if 2-3 is a covalent bond, 1-2 and 3-4 pairs
C---- are scanned for covalent interactions
C----
      write (11,1560)
      do i=1,nbond
         call bonded(b1,b2,nbond,b1(i),ibonds,idum)
         call bonded(b1,b2,nbond,b2(i),jbonds,jdum)
         do j=1,idum
            k=ibonds(j)
            if (k.ne.b2(i)) then
               do m=1,jdum
                  l=jbonds(m)
                  if (l.ne.b1(i)) then
                     len=getlen(k,l,xref)*10.0
                     if (.not.had(k,l,npair,ihad)) then
                        if (acc(k).lt.0.2) then
                           lsig=sigma(6,1,1)
                           usig=sigma(6,1,2)
                        else
                           lsig=sigma(6,2,1)
                           usig=sigma(6,2,2)
                        endif
                        ub=len+usig
                        lb=len-lsig
                        write(11,1112) k,l,len,lb,ub
                        n14=n14+1
                     endif
                  endif
               enddo
            endif
         enddo
      enddo
      write(6,1660) n14
C----
C---- secondary structure restricted pairs
C----
      if (dsspflg) then
         call getsecstr1(atnam,type,atrad,resnr,hst,xref,
     &        sigma,maxcat,nat,npair,ihad,11,libdir,resid,resnam,nhst)
         call getsecstr2(atnam,type,atrad,resnr,hst,xref,sigma,maxcat,
     &        nat,npair,ihad,11,libdir,resid,resnam,nhst,hbond,
     &        nhbo_tight)
      endif
C----
C---- get charges
C----
      call getcharge(resnam,atnam,nat,charge,libdir,term,chdis)
C----
C---- get hydrogen bond donors/acceptors
C----
      if (.not.dsspflg) 
     &     call getdonacc(donacc,atnam,resnam,nat,libdir,hbdis)
C----
C---- get non-bonded interacting pairs
C----
      if (nonflg) then
         call getnonbond1(donacc,pol,charge,atrad,type,xref,nat,
     &        npair,ihad,rcut,sigma,maxcat,11,nnonbond,libdir)
      else
         call getnonbond2(donacc,pol,charge,atrad,xref,nat,
     &        npair,ihad,rcut,sigma,maxcat,11,nnonbond,
     &        hbdis,chdis,type,libdir,resnr,resnam,atnam,acc,hbond,nhbo,
     &        nhbo_tight,hst,dsspflg)
      endif
C---- 
C---- find more pairs to satisfy minimal nr of distances per atom
C----
      call getother(nat,xref,npair,ihad,type,atrad,libdir,11,
     &     mindis,sigma,maxcat,noth)

c      write(6,2120) nbond+n13+nring+nomega
      ndist=nbond+n13+nring+nomega+npp+n14+nhst+nnonbond+noth
      write(6,1670) nnonbond
      write(6,2150) ndist
      if (ndist.gt.MAXDIS) then
         write(0,*) 'Warning: increase MAXDIS in ',
     &        'parameter file to at least ',ndist
         nwarn=nwarn+1
      endif

      if (nwarn.eq.0) then
         write(6,2300)
      else
         write(6,2310) nwarn
      endif
         
 1000 format (a80)
 1001 format ('error - file not found:')
 1005 format (i5)
 1010 format (i5,2a5,i5,3f8.3)
 1112 format (2i5,4f10.4)
 1150 format (12x,a4,1x,a4,a1,a4,4x,3f8.3,f6.2)
 1151 format ('ATOM  ',i5,1x,a4,1x,a3,1x,a1,i4,4x,3f8.3,f6.2,'  0.00')
 1152 format (' ',a3)
 1200 format ('command line options:')
 1201 format ('pdb input coordinate file...........: ',a40)
 1202 format ('GROMOS87 input coordinate file......: ',a40)
 1203 format ('Warning: no dssp calculation will be performed. Expect',
     &        ' poor results!')
 1204 format ('dssp executable.....................: ',a40)
 1205 format ('hydrogen atoms (if any) will be removed')
 1206 format ('hydrogen atoms (if any) will be retained')
 1208 format ('non-bonded cut-off radius...........: ',f6.2,
     &        ' A + VDW sum')
 1209 format ('minimal nr. of distances per atom...: ',i6)
 1210 format ('output distances....................: ',a40)
 1211 format ('output coordinates (PDB)............: ',a40)
 1212 format ('output coordinates (GROMOS87).......: ',a40)
 1215 format ('trying to find alternative non-bonded parameters')
 1216 format ('non-bonded contacts of starting structure will be ',
     &     'preserved')
 1220 format ('processing input...')
 1250 format ('dist: unknown command line argument: ',a40)
 1251 format ('error: either -g or -p must be specified')
 1252 format ('error: both -g and -p are used simultaneously')
 1300 format ('WARNING: some atoms will be fixed in structure ',
     &        'generation (zero occupancy/weight encountered)')
 1301 format ('WARNING: please edit the occupancy column of the',
     &        ' input PDB file if this is undesired')
 1302 format ('WARNING WARNING WARNING WARNING WARNING WARNING')
 1520 format ('#Ring restrictions')
 1525 format ('#Quasi ring restrictions')
 1540 format ('#Omega restrictions')
 1550 format ('#Tight phi/psi restrictions')
 1552 format ('#Other phi/psi restrictions')
 1560 format ('#1-4 restrictions')
 1620 format ('counted',i7,' ring restrictions')
 1640 format ('counted',i7,' omega restrictions')
 1650 format ('counted',i7,' tight phi/psi restrictions')
 1652 format ('counted',i7,' other phi/psi restrictions')
 1660 format ('counted',i7,' other 1-4 restrictions')
 1670 format ('total nr of non-bonded pairs:',i7)
 2010 format ('total number of atoms       : ',i5)
 2020 format ('number of atoms to be used  : ',i5)
 2025 format ('number of residues          : ',i5)
 2040 format ('DSSP secondary structure information:')
 2042 format (5(7x,i3))
 2045 format (50i1)
 2050 format (50a1)
 2150 format ('total number of constraints :',i7)
 2300 format ('normal termination')
 2310 format (i2,' warnings encountered. Please investigate!')
 5000 format ('HEADER    Structure generated by dist')
 5001 format ('END')
      end

      subroutine usage()

      implicit none

      write(0,100)
      write(0,110)
      write(0,120)
      write(0,*)
      write(0,130)

      stop

 100  format('Usage: dist -g <file> (or -p <file>) [-dssp <name>]')
 110  format('            [-r] [-nb] [-c value] [-m value] ',
     &     '[-damp value]')
 120  format('            [-op <file>] [-og <file>] [-od <file>] [-h]')
 130  format('dist -h will give some additional information')

      end

      subroutine manual()

      implicit none

      write(0,100)
      write(0,110)
      write(0,120)
      write(0,*)
      write(0,130)
      write(0,131)
      write(0,132)
      write(0,133)
      write(0,*)
      write(0,140)
      write(0,141)
      write(0,142)
      write(0,143)
      write(0,144)
      write(0,145)
      write(0,146)
      write(0,147)
      write(0,148)
      write(0,162)
      write(0,163)
      write(0,149)
      write(0,150)
      write(0,159)
      write(0,152)
      write(0,153)
      write(0,154)
      write(0,155)
      write(0,156)
      write(0,157)
      write(0,158)

      stop

 100  format('Usage: dist -g <file> (or -p <file>) [-dssp <name>]')
 110  format('            [-r] [-nb] [-c value] [-m value] ',
     &     '[-damp value]')
 120  format('            [-op <file>] [-og <file>] [-od <file>] [-h]')
 130  format('dist sorts pairs of interacting atoms in a (protein)')
 131  format('structure from a single conformation. The result can')
 132  format('be used by the program disco to generate multiple')
 133  format('conformations.')
 140  format('Command line options:')
 141  format('-g <file>    - name of input GROMOS87 coordinate file')
 142  format('-p <file>    - name of input PDB coordinate file (either')
 143  format('               -g or -p is mandatory, from these')
 144  format('               coordinates the distances are calculated)')
 145  format('-dssp <file> - DSSP can be used for determining')
 146  format('               secondary structure-related pairs ',
     &       '(recommended!)')
 147  format('               <file> is the name of the dssp executable')
 148  format('-r           - retain hydrogen atoms (by default they ',
     &       'will be removed)')
 162  format('-nb          - try to find alternatives for',
     &     ' non-bonded interactions')
 163  format('               (by default the native contacts will be ',
     &     ' preserved)')
 149  format('-c value     - cut-off radius (Angstroms) for')
 150  format('               non-bonded interacting pairs (default',
     &                       ' 4.0)')
 152  format('-m value     - minimum nr of distances to be defined for')
 153  format('               each atom (default 100)')
 154  format('-damp value  - multiply each distance margin by value ',
     &     '(default 1.0)')
 155  format('-op <file>   - output structure in PDB ',
     &       'file format (default dist.pdb)')
 156  format('-og <file>   - output GROMOS87 coordinate ',
     &       'file (default dist.gro)')
 157  format('-od <file>   - output file containing distances ',
     &                       '(default dist.dat)')
 158  format('-h           - displays this message')
 159  format('               (the cut-off distances are additional to',
     &                       ' the sum of VDW radii)')

      end
